/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                 Program 17.7
    Code written by: Sogand Parvaneh Masiha
*/
#include<stdio.h>

class Matrix
{
public:
  int size;
  double **px;
  void read(int s)
  {
    size = s;
    px = new double*[size];
    int i = 0, j = 0;
    for (i=0;i<size;i++)
    {
      px[i] = new double[size];
    }
    for (i=0;i<size;i++)
    {
      for (j=0;j<size;j++)
      {
        printf("p[%d][%d] = ",i,j); 
        scanf("%lf",&px[i][j]);
      }
    }
    size = s;
  }
  void print()
  {
    printf("matrix is:\n");
    for (int i=0;i<size;i++)
    {
      for (int j=0;j<size;j++)
      {
        printf("%10.5lf",px[i][j]);
      }
      printf("\n");
    }
  }
  virtual double determinant()=0;
};

class Mat2x2:public Matrix
{
public:

  virtual double determinant()
  {
    double sum=0;
    sum=px[0][0]*px[1][1]-px[0][1]*px[1][0];
    return sum;
  }
};

class Mat3x3:public Matrix
{
public:

  virtual double determinant()
  {
    double sum2=0;
    sum2=px[0][0]*px[1][1]*px[2][2]+px[0][1]*px[1][2]*px[2][0]
    +px[0][2]*px[1][0]*px[2][1]-px[0][1]*px[1][0]*px[2][2]
    -px[0][0]*px[1][2]*px[2][1]-px[0][2]*px[1][1]*px[2][0];
    return sum2;
  }
};

int main()
{
  Matrix * mat;
  int size;
  while (1)
  {
    printf("Please enter the size of the matrix (2 or 3): ");
    scanf("%d",&size) ;
    if(size==2) 
    {
      mat= new Mat2x2();
      break;
    }
    else if(size==3)
    {
      mat= new Mat3x3();
      break;
    }
    else
    {
      printf("Not a valid dimension. Please try again!\n\n");
    }
  }
  mat->read(size);
  mat->print();
  printf("\ndeterminant = %10.5lf",mat->determinant());
  getchar();
  getchar();
  return 0;
}